library(stockassessment)
load("run/model.RData")
###############################
#
# 
#  
##############################

#  Reference points  
F_MSY <- 0.3
F_MSY_lower <- 0.18
F_MSY_upper <- 0.49
Fpa <- 0.57 #  New Fpa = Fp05 from WKDEM 2020, previously Fpa=0.52
Flim <- 0.73
Blim <- 14376
Bpa <- 20126
MSY_Btrigger <- 20126

# TAC & advice for 2021

prev.advice <- 0 # not used
prev.TAC <-1279 #this was 2021 & 2022

#2021 catch
prev.cat <-1610


#~~~~~~~~~~~~~~~~~~~~~~
#  FORECAST ASSUMPTIONS
#
# ---- Using the final year in the assessment (intermediate year) allows use of model estimate int yr Rec
final.yr <-max(fit$data$years)
# ---- Resample R from previous 10 years Rec
R.range <-(final.yr-9):final.yr
# ---- Use final year for mean weights & L-D partition
av.yrs <-(final.yr-2):final.yr
#----- Use 3 year average selection patter
sel.yrs <-(final.yr-2):final.yr
# ---- F status quo is 3 year average
f_mean <-mean(fbartable(fit)[as.character(sel.yrs),"Estimate"])

f_final <-fbartable(fit)[as.character(final.yr),"Estimate"]

fit1 <-fit
fit1$data$disMeanWeight[as.character(final.yr),1:2] <-NA

#########  forecast   ##########

FC<-list()
NSIM <-10000



# 2021F=Fsq then zero
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit1, fscale=c(NA,NA,0.0,0.0), fval=c(f_final,f_mean,NA,NA), year.base = final.yr,
                               label="2022F=Fsq then zero", rec.years=R.range, ave.years = av.yrs,
                               overwriteSelYears = sel.yrs,splitLD = TRUE,nosim=NSIM,savesim=TRUE)

# 2021F=Fsq then Fmsy

#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA), fval=c(f_mean,F_MSY,F_MSY), year.base = final.yr,
##                               label="2021F=Fsq then Fmsy", rec.years=R.range,ave.years = av.yrs,
#                               overwriteSelYears = sel.yrs,splitLD = TRUE,nosim=NSIM)


save(FC, file="run/forecast.RData")
